Servlet and JavaServer Pages API Documentation: Class PageContext

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.servlet.jsp
Class PageContext

    java.lang.Object
      |
      +--javax.servlet.jsp.PageContext

public abstract class PageContext
extends java.lang.Object

A PageContext instance provides access to all the namespaces associated with a JSP page, provides access to several page attributes, as well as a layer above the implementation details.

An instance of an implementation dependent subclass of this abstract base class is created by a JSP implementation class at the begining of it's `_jspService()` method via an implementation default `JspFactory` , as follows:

``

     public class foo implements Servlet {

     // ...

    public void _jspService(HttpServletRequest request,
    			HttpServletResponse response)
           throws IOException, ServletException {

        JspFactory  factory     = JspFactory.getDefaultFactory();
        PageContext pageContext = factory.getPageContext(
    this,
    request,
    response,
    null,  // errorPageURL
    false, // needsSession
    JspWriter.DEFAULT_BUFFER,
    true   // autoFlush
    );

        // initialize implicit variables for scripting env ...

        HttpSession session = pageContext.getSession();
        JspWriter   out     = pageContext.getOut();
        Object      page    = this;

        try {
            // body of translated JSP here ...
        } catch (Exception e) {
            out.clear();
            pageContext.handlePageException(e);
        } finally {
            out.close();
    	  factory.releasePageContext(pageContext);
        }
    }

The `PageContext` class is an abstract class, designed to be extended to provide implementation dependent implementations thereof, by conformant JSP engine runtime environments. A PageContext instance is obtained by a JSP implementation class by calling the JspFactory.getPageContext() method, and is released by calling JspFactory.releasePageContext().

The PageContext provides a number of facilities to the page/component author and page implementor, including:

- a single API to manage the various scoped namespaces
- a number of convenience API's to access various public objects
- a mechanism to obtain the JspWriter for output
- a mechanism to manage session usage by the page
- a mechanism to expose page directive attributes to the scripting environment
- mechanisms to forward or include the current request to other active components in the application
- a mechanism to handle errorpage exception processing

  Field Summary
  `static java.lang.String` | `APPLICATION` name used to store ServletContext in PageContext name table
  `static int` | `APPLICATION_SCOPE` application scope: named reference remains available in the ServletContext until it is reclaimed.
  `static java.lang.String` | `CONFIG` name used to store ServletConfig in PageContext name table
  `static java.lang.String` | `EXCEPTION` name used to store uncaught exception in ServletRequest attribute list and PageContext name table
  `static java.lang.String` | `OUT` name used to store current JspWriter in PageContext name table
  `static java.lang.String` | `PAGE` name used to store the Servlet in this PageContext's nametables
  `static int` | `PAGE_SCOPE` page scope: (this is the default) the named reference remains available in this PageContext until the return from the current Servlet.service() invocation.
  `static java.lang.String` | `PAGECONTEXT` name used to store this PageContext in it's own name tables
  `static java.lang.String` | `REQUEST` name used to store ServletRequest in PageContext name table
  `static int` | `REQUEST_SCOPE` request scope: the named reference remains available from the ServletRequest associated with the Servlet that until the current request is completed.
  `static java.lang.String` | `RESPONSE` name used to store ServletResponse in PageContext name table
  `static java.lang.String` | `SESSION` name used to store HttpSession in PageContext name table
  `static int` | `SESSION_SCOPE` session scope (only valid if this page participates in a session): the named reference remains available from the HttpSession (if any) associated with the Servlet until the HttpSession is invalidated.

  Constructor Summary
  `PageContext()`

  Method Summary
  `abstract java.lang.Object` | `findAttribute(java.lang.String name)` Searches for the named attribute in page, request, session (if valid), and application scope(s) in order and returns the value associated or null.
  `abstract void` | `forward(java.lang.String relativeUrlPath)` This method is used to re-direct, or "forward" the current ServletRequest and ServletResponse to another active component in the application.
  `abstract java.lang.Object` | `getAttribute(java.lang.String name)` return the object associated with the name in the page scope or null
  `abstract java.lang.Object` | `getAttribute(java.lang.String name, int scope)` return the object associated with the name in the specifed scope or null
  `abstract java.util.Enumeration` | `getAttributeNamesInScope(int scope)`
  `abstract int` | `getAttributesScope(java.lang.String name)`
  `abstract java.lang.Exception` | `getException()`
  `abstract JspWriter` | `getOut()`
  `abstract java.lang.Object` | `getPage()`
  `abstract ServletRequest` | `getRequest()`
  `abstract ServletResponse` | `getResponse()`
  `abstract ServletConfig` | `getServletConfig()`
  `abstract ServletContext` | `getServletContext()`
  `abstract HttpSession` | `getSession()`
  `abstract void` | `handlePageException(java.lang.Exception e)` This method is intended to process an unhandled "page" level exception by redirecting the exception to either the specified error page for this JSP, or if none was specified, to perform some implementation dependent action.
  `abstract void` | `include(java.lang.String relativeUrlPath)` Causes the resource specified to be processed as part of the current ServletRequest and ServletResponse being processed by the calling Thread.
  `abstract void` | `initialize(Servlet servlet, ServletRequest request, ServletResponse response, java.lang.String errorPageURL, boolean needsSession, int bufferSize, boolean autoFlush)` The initialize emthod is called to initialize an uninitialized PageContext so that it may be used by a JSP Implementation class to service an incoming request and response wihtin it's _jspService() method.
  `JspWriter` | `popBody()` Return the previous JspWriter "out" saved by the matching pushBody(), and update the value of the "out" attribute in the page scope attribute namespace of the PageConxtext
  `BodyContent` | `pushBody()` Return a new BodyContent object, save the current "out" JspWriter, and update the value of the "out" attribute in the page scope attribute namespace of the PageContext
  `abstract void` | `release()` This method shall "reset" the internal state of a PageContext, releasing all internal references, and preparing the PageContext for potential reuse by a later invocation of initialize().
  `abstract void` | `removeAttribute(java.lang.String name)` remove the object reference associated with the specified name
  `abstract void` | `removeAttribute(java.lang.String name, int scope)` remove the object reference associated with the specified name
  `abstract void` | `setAttribute(java.lang.String name, java.lang.Object attribute)` register the name and object specified with page scope semantics
  `abstract void` | `setAttribute(java.lang.String name, java.lang.Object o, int scope)` register the name and object specified with appropriate scope semantics

  Methods inherited from class java.lang.Object
  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  Field Detail

  ### PAGE_SCOPE

      public static final int PAGE_SCOPE

    page scope: (this is the default) the named reference remains available in this PageContext until the return from the current Servlet.service() invocation.

  ### REQUEST_SCOPE

      public static final int REQUEST_SCOPE

    request scope: the named reference remains available from the ServletRequest associated with the Servlet that until the current request is completed.

  ### SESSION_SCOPE

      public static final int SESSION_SCOPE

    session scope (only valid if this page participates in a session): the named reference remains available from the HttpSession (if any) associated with the Servlet until the HttpSession is invalidated.

  ### APPLICATION_SCOPE

      public static final int APPLICATION_SCOPE

    application scope: named reference remains available in the ServletContext until it is reclaimed.

  ### PAGE

      public static final java.lang.String PAGE

    name used to store the Servlet in this PageContext's nametables

  ### PAGECONTEXT

      public static final java.lang.String PAGECONTEXT

    name used to store this PageContext in it's own name tables

  ### REQUEST

      public static final java.lang.String REQUEST

    name used to store ServletRequest in PageContext name table

  ### RESPONSE

      public static final java.lang.String RESPONSE

    name used to store ServletResponse in PageContext name table

  ### CONFIG

      public static final java.lang.String CONFIG

    name used to store ServletConfig in PageContext name table

  ### SESSION

      public static final java.lang.String SESSION

    name used to store HttpSession in PageContext name table

  ### OUT

      public static final java.lang.String OUT

    name used to store current JspWriter in PageContext name table

  ### APPLICATION

      public static final java.lang.String APPLICATION

    name used to store ServletContext in PageContext name table

  ### EXCEPTION

      public static final java.lang.String EXCEPTION

    name used to store uncaught exception in ServletRequest attribute list and PageContext name table

  Constructor Detail

  ### PageContext

      public PageContext()

  Method Detail

  ### initialize

      public abstract void initialize(Servlet servlet,
                                      ServletRequest request,
                                      ServletResponse response,
                                      java.lang.String errorPageURL,
                                      boolean needsSession,
                                      int bufferSize,
                                      boolean autoFlush)
                               throws java.io.IOException,
                                      java.lang.IllegalStateException,
                                      java.lang.IllegalArgumentException

    The initialize emthod is called to initialize an uninitialized PageContext so that it may be used by a JSP Implementation class to service an incoming request and response wihtin it's _jspService() method.

    This method is typically called from JspFactory.getPageContext() in order to initialize state.

    This method is required to create an initial JspWriter, and associate the "out" name in page scope with this newly created object.

    Parameters:
      `servlet` - The Servlet that is associated with this PageContext
      `request` - The currently pending request for this Servlet
      `response` - The currently pending response for this Servlet
      `errorPageURL` - The value of the errorpage attribute from the page directive or null
      `needsSession` - The value of the session attribute from the page directive
      `bufferSize` - The value of the buffer attribute from the page directive
      `autoFlush` - The value of the autoflush attribute from the page directive
    Throws:
      java.io.IOException - during creation of JspWriter
      java.lang.IllegalStateException - if out not correctly initialized

  ### release

      public abstract void release()

    This method shall "reset" the internal state of a PageContext, releasing all internal references, and preparing the PageContext for potential reuse by a later invocation of initialize(). This method is typically called from JspFactory.releasePageContext().

    subclasses shall envelope this method

  ### setAttribute

      public abstract void setAttribute(java.lang.String name,
                                        java.lang.Object attribute)

    register the name and object specified with page scope semantics
    Throws:
      NullPointerException - if the name or object is null

  ### setAttribute

      public abstract void setAttribute(java.lang.String name,
                                        java.lang.Object o,
                                        int scope)

    register the name and object specified with appropriate scope semantics
    Parameters:
      `name` - the name of the attribute to set
      `o` - the object to associate with the name
      `scope` - the scope with which to associate the name/object
    Throws:
      NullPointerException - if the name or object is null
      java.lang.IllegalArgumentException - if the scope is invalid

  ### getAttribute

      public abstract java.lang.Object getAttribute(java.lang.String name)

    return the object associated with the name in the page scope or null

    Parameters:
      `name` - the name of the attribute to get
    Throws:
      NullPointerException - if the name is null
      java.lang.IllegalArgumentException - if the scope is invalid

  ### getAttribute

      public abstract java.lang.Object getAttribute(java.lang.String name,
                                                    int scope)

    return the object associated with the name in the specifed scope or null

    Parameters:
      `name` - the name of the attribute to set
      `scope` - the scope with which to associate the name/object
    Throws:
      NullPointerException - if the name is null
      java.lang.IllegalArgumentException - if the scope is invalid

  ### findAttribute

      public abstract java.lang.Object findAttribute(java.lang.String name)

    Searches for the named attribute in page, request, session (if valid), and application scope(s) in order and returns the value associated or null.

    Returns:
      the value associated or null

  ### removeAttribute

      public abstract void removeAttribute(java.lang.String name)

    remove the object reference associated with the specified name

  ### removeAttribute

      public abstract void removeAttribute(java.lang.String name,
                                           int scope)

    remove the object reference associated with the specified name

  ### getAttributesScope

      public abstract int getAttributesScope(java.lang.String name)

    Returns:
      the scope of the object associated with the name specified or 0

  ### getAttributeNamesInScope

      public abstract java.util.Enumeration getAttributeNamesInScope(int scope)

    Returns:
      an enumeration of names (java.lang.String) of all the attributes the specified scope

  ### getOut

      public abstract JspWriter getOut()

    Returns:
      the current JspWriter stream being used for client response

  ### getSession

      public abstract HttpSession getSession()

    Returns:
      the HttpSession for this PageContext or null

  ### getPage

      public abstract java.lang.Object getPage()

    Returns:
      the Page implementation class instance (Servlet) associated with this PageContext

  ### getRequest

      public abstract ServletRequest getRequest()

    Returns:
      The ServletRequest for this PageContext

  ### getResponse

      public abstract ServletResponse getResponse()

    Returns:
      the ServletResponse for this PageContext

  ### getException

      public abstract java.lang.Exception getException()

    Returns:
      any exception passed to this as an errorpage

  ### getServletConfig

      public abstract ServletConfig getServletConfig()

    Returns:
      the ServletConfig for this PageContext

  ### getServletContext

      public abstract ServletContext getServletContext()

    Returns:
      the ServletContext for this PageContext

  ### forward

      public abstract void forward(java.lang.String relativeUrlPath)
                            throws ServletException,
                                   java.io.IOException

    This method is used to re-direct, or "forward" the current ServletRequest and ServletResponse to another active component in the application.

    If the relativeUrlPath begins with a "/" then the URL specified is calculated relative to the DOCROOT of the `ServletContext` for this JSP. If the path does not begin with a "/" then the URL specified is calculated relative to the URL of the request that was mapped to the calling JSP.

    It is only valid to call this method from a `Thread` executing within a `_jspService(...)` method of a JSP.

    Once this method has been called successfully, it is illegal for the calling `Thread` to attempt to modify the `ServletResponse` object. Any such attempt to do so, shall result in undefined behavior. Typically, callers immediately return from `_jspService(...)` after calling this method.

    Parameters:
      `relativeUrlPath` - specifies the relative URL path to the target resource as described above
    Throws:
      ServletException -
      java.io.IOException -
      java.lang.IllegalArgumentException - if target resource URL is unresolvable
      java.lang.IllegalStateException - if `ServletResponse` is not in a state where a forward can be performed
      java.lang.SecurityException - if target resource cannot be accessed by caller

  ### include

      public abstract void include(java.lang.String relativeUrlPath)
                            throws ServletException,
                                   java.io.IOException

    Causes the resource specified to be processed as part of the current ServletRequest and ServletResponse being processed by the calling Thread. The output of the target resources processing of the request is written directly to the ServletResponse output stream.

    The current JspWriter "out" for this JSP is flushed as a side-effect of this call, prior to processing the include.

    If the relativeUrlPath begins with a "/" then the URL specified is calculated relative to the DOCROOT of the `ServletContext` for this JSP. If the path does not begin with a "/" then the URL specified is calculated relative to the URL of the request that was mapped to the calling JSP.

    It is only valid to call this method from a `Thread` executing within a `_jspService(...)` method of a JSP.

    Parameters:
      `relativeUrlPath` - specifies the relative URL path to the target resource to be included
    Throws:
      ServletException -
      java.io.IOException -
      java.lang.IllegalArgumentException - if the target resource URL is unresolvable
      java.lang.SecurityException - if target resource cannot be accessed by caller

  ### handlePageException

      public abstract void handlePageException(java.lang.Exception e)
                                        throws ServletException,
                                               java.io.IOException

    This method is intended to process an unhandled "page" level exception by redirecting the exception to either the specified error page for this JSP, or if none was specified, to perform some implementation dependent action.

    A JSP implementation class shall typically clean up any local state prior to invoking this and will return immediately thereafter. It is illegal to generate any output to the client, or to modify any ServletResponse state after invoking this call.

    Parameters:
      `e` - the exception to be handled
    Throws:
      ServletException -
      java.io.IOException -
      NullPointerException - if the exception is null
      java.lang.SecurityException - if target resource cannot be accessed by caller

  ### pushBody

      public BodyContent pushBody()

    Return a new BodyContent object, save the current "out" JspWriter, and update the value of the "out" attribute in the page scope attribute namespace of the PageContext
    Returns:
      the new BodyContent

  ### popBody

      public JspWriter popBody()

    Return the previous JspWriter "out" saved by the matching pushBody(), and update the value of the "out" attribute in the page scope attribute namespace of the PageConxtext
    Returns:
      the saved JspWriter.

  Overview | Package | Class | Use | Tree | Deprecated | Index | Help
  PREV CLASS NEXT CLASS | FRAMES NO FRAMES
  SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

  Copyright (c) 1999-2000 The Apache Software Foundation. All Rights Reserved.